/*
 * 公告消息
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MsgPlacardController : BaseController
    {
        public MsgPlacardController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 公告消息列表

        /// <summary>
        /// 根据条件查询公告消息列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MsgPlacard data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询公告消息列表

        /// <summary>
        /// 公告消息列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MsgPlacard data, string MsgTypeSelect, string StatusSelect, string PushTypeSelect, string PushFlagSelect, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Title", "2"); //标题
            
            string condition = " and Status>-1";
            //消息类型
            if(!string.IsNullOrEmpty(MsgTypeSelect))
            {
                condition += " and MsgType=" + MsgTypeSelect;
            }
            //状态
            if(!string.IsNullOrEmpty(StatusSelect))
            {
                condition += " and Status=" + StatusSelect;
            }
            //推送类型
            if(!string.IsNullOrEmpty(PushTypeSelect))
            {
                condition += " and PushType=" + PushTypeSelect;
            }
            //推送标记
            if(!string.IsNullOrEmpty(PushFlagSelect))
            {
                condition += " and PushFlag=" + PushFlagSelect;
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MsgPlacard", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //消息类型
                int MsgType = int.Parse(dic["MsgType"].ToString());
                if(MsgType == 0) dic["MsgType"] = "html页面";
                if(MsgType == 1) dic["MsgType"] = "指定url";
                if(MsgType == 2) dic["MsgType"] = "简单中文描述";
                
                //推送类型
                int PushType = int.Parse(dic["PushType"].ToString());
                if(PushType == 0) dic["PushType"] = "不推送";
                if(PushType == 1) dic["PushType"] = "立即推送";
                if(PushType == 2) dic["PushType"] = "定时推送";
                
                //推送标记
                int PushFlag = int.Parse(dic["PushFlag"].ToString());
                if(PushFlag == 0) dic["PushFlag"] = "不推送";
                if(PushFlag == 1) dic["PushFlag"] = "未推送";
                if(PushFlag == 2) dic["PushFlag"] = "已推送";
            }
            return Json(obj);
        }

        #endregion

        #region 增加公告消息

        /// <summary>
        /// 增加或修改公告消息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加公告消息

        /// <summary>
        /// 增加或修改公告消息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MsgPlacard data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("MsgType", data.MsgType); //消息类型
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Summary", data.Summary); //简介
            Fields.Add("Content", data.Content); //内容
            Fields.Add("ShowType", data.ShowType); //展示类型
            Fields.Add("EffectStartDate", data.EffectStartDate); //有效开始时间
            Fields.Add("EffectEndDate", data.EffectEndDate); //有效结束时间
            Fields.Add("BgPic", data.BgPic); //背景图片
            Fields.Add("PushType", data.PushType); //推送类型
            Fields.Add("PushFlag", data.PushFlag); //推送标记
            Fields.Add("PushParam", data.PushParam); //推送参数
            Fields.Add("PushTime", data.PushTime); //推送时间
            Fields.Add("ExtendColumn", data.ExtendColumn); //扩展字段
            Fields.Add("Remark", data.Remark); //备注
            Fields.Add("Url", data.Url); //跳转Url

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MsgPlacard", Fields, 0);
            AddSysLog(Id.ToString(), "MsgPlacard", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改公告消息

        /// <summary>
        /// 增加或修改公告消息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            MsgPlacard editData = db.MsgPlacard.FirstOrDefault(m => m.Id == Id) ?? new MsgPlacard();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改公告消息

        /// <summary>
        /// 增加或修改公告消息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MsgPlacard data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("MsgType", data.MsgType); //消息类型
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Summary", data.Summary); //简介
            Fields.Add("Content", data.Content); //内容
            Fields.Add("ShowType", data.ShowType); //展示类型
            Fields.Add("EffectStartDate", data.EffectStartDate); //有效开始时间
            Fields.Add("EffectEndDate", data.EffectEndDate); //有效结束时间
            Fields.Add("BgPic", data.BgPic); //背景图片
            Fields.Add("PushType", data.PushType); //推送类型
            Fields.Add("PushFlag", data.PushFlag); //推送标记
            Fields.Add("PushParam", data.PushParam); //推送参数
            Fields.Add("PushTime", data.PushTime); //推送时间
            Fields.Add("ExtendColumn", data.ExtendColumn); //扩展字段
            Fields.Add("Remark", data.Remark); //备注
            Fields.Add("Url", data.Url); //跳转Url

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MsgPlacard", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "MsgPlacard", "update");
            db.SaveChanges();
            
            SetRedis(data.Id, true);

            return "success";
        }

        #endregion

        #region 详情

        public IActionResult Detail(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            MsgPlacard editData = db.MsgPlacard.FirstOrDefault(m => m.Id == Id) ?? new MsgPlacard();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 删除公告消息信息

        /// <summary>
        /// 删除公告消息信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MsgPlacard", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MsgPlacard", Fields, id);
                SetRedis(0, true);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MsgPlacard", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MsgPlacard", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MsgPlacard", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MsgPlacard", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MsgPlacard", Sort, Id);

            AddSysLog(Id.ToString(), "MsgPlacard", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MsgPlacard.Add(new MsgPlacard()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MsgPlacard", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MsgPlacard data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("MsgType", "1"); //消息类型
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("Title", "2"); //标题
            Fields.Add("PushType", "1"); //推送类型
            Fields.Add("PushFlag", "1"); //推送标记

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MsgPlacard", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MsgPlacard", "ExportExcel");
            return Json(result);
        }

        #endregion




        #region 设置缓存

        private void SetRedis(int Id, bool All)
        {
            if (All)
            {
                RedisDbconn.Instance.Clear("MsgPlacardList");
                var msgs = db.MsgPlacard.Select(m => new { m.Id, m.Status, m.Sort }).Where(m => m.Status > -1).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
                foreach (var msg in msgs)
                {
                    RedisDbconn.Instance.AddList("MsgPlacardList", msg.Id);
                }
            }
            if (Id > 0)
            {
                MsgPlacard edit = db.MsgPlacard.FirstOrDefault(m => m.Id == Id);
                if (edit != null)
                {
                    RedisDbconn.Instance.Set("MsgPlacard:" + Id, edit);
                }
            }
        }

        #endregion
    }
}
